Bug 1104524 (CVE-2014-3476) - CVE-2014-3476 openstack-keystone: privilege escalation through trust chained delegation
Summary: CVE-2014-3476 openstack-keystone: privilege escalation through trust chained ...
Keywords:
Status: CLOSED ERRATA
Alias: CVE-2014-3476
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
high
high
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1108967 1104538 1104539 1104576 1104577 1108964 1108965
Blocks: 1104532
TreeView+ depends on / blocked
 
Reported: 2014-06-04 07:58 UTC by Garth Mollett
Modified: 2019-09-29 13:18 UTC (History)
14 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
A flaw was found in keystone's chained delegation. A trustee able to create a delegation from a trust or an OAuth token could misuse identity impersonation to bypass the enforced scope, possibly allowing them to obtain elevated privileges to the trustor's projects and roles.
Clone Of:
Environment:
Last Closed: 2014-08-01 05:43:56 UTC


Attachments (Terms of Use)
CVE-2014-3476 patch for stable/havana (14.35 KB, patch)
2014-06-09 16:56 UTC, Vincent Danen
no flags Details | Diff
CVE-2014-3476 patch for stable/icehouse (11.97 KB, patch)
2014-06-09 16:57 UTC, Vincent Danen
no flags Details | Diff
CVE-2014-3476 patch for master (juno) (11.87 KB, patch)
2014-06-09 16:57 UTC, Vincent Danen
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2014:0994 normal SHIPPED_LIVE Important: openstack-keystone security update 2014-07-31 19:18:04 UTC

Description Garth Mollett 2014-06-04 07:58:17 UTC
Openstack VMT reports:

Title: Keystone privilege escalation through trust chained delegation
Reporter: Steven Hardy (Red Hat)
Products: Keystone
Versions: up to 2013.2.3, and 2014.1 to 2014.1.1

Description:
Steven Hardy from Red Hat reported a vulnerability in Keystone chained delegation.
By creating a delegation from a trust or OAuth token, a trustee may abuse the identity impersonation against keystone and circumvent the enforced scope, resulting in potential elevated privileges to any of the trustor's projects and or roles. All Keystone deployments configured to enable trusts are affected, which has been the default since Grizzly.

Comment 1 Garth Mollett 2014-06-04 08:12:02 UTC
Acknowledgements:

This issue was discovered by Steven Hardy of Red Hat.

Comment 5 Vincent Danen 2014-06-09 16:56:42 UTC
Created attachment 904902 [details]
CVE-2014-3476 patch for stable/havana

Comment 6 Vincent Danen 2014-06-09 16:57:20 UTC
Created attachment 904920 [details]
CVE-2014-3476 patch for stable/icehouse

Comment 7 Vincent Danen 2014-06-09 16:57:48 UTC
Created attachment 904933 [details]
CVE-2014-3476 patch for master (juno)

Comment 8 Alan Pevec 2014-06-13 01:01:21 UTC
(In reply to Vincent Danen from comment #5)
> Created attachment 904902 [details]
> CVE-2014-3476 patch for stable/havana

There has been a minor change in posted Havana review (unit tests only):
https://review.openstack.org/#/c/99703/1..2/keystone/tests/test_v3_auth.py,unified

Comment 9 Alan Pevec 2014-06-13 01:02:28 UTC
This is now public
 http://lists.openstack.org/pipermail/openstack-announce/2014-June/000240.html

Please create Fedora clone.

Comment 10 Murray McAllister 2014-06-13 02:25:13 UTC
Created openstack-keystone tracking bugs for this issue:

Affects: fedora-all [bug 1108964]
Affects: epel-6 [bug 1108965]

Comment 14 Martin Prpič 2014-07-31 14:50:37 UTC
IssueDescription:

A flaw was found in keystone's chained delegation. A trustee able to create a delegation from a trust or an OAuth token could misuse identity impersonation to bypass the enforced scope, possibly allowing them to obtain elevated privileges to the trustor's projects and roles.

Comment 15 errata-xmlrpc 2014-07-31 15:18:13 UTC
This issue has been addressed in following products:

  OpenStack 3 for RHEL 6
  OpenStack 4 for RHEL 6

Via RHSA-2014:0994 https://rhn.redhat.com/errata/RHSA-2014-0994.html

Comment 16 Fedora Update System 2014-08-07 15:24:17 UTC
openstack-keystone-2013.2.3-5.fc20 has been pushed to the Fedora 20 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.